#ifndef RT_LAUNCHER_GAME_API_H
#define RT_LAUNCHER_GAME_API_H

#include <runtime/runtime.h>
#include <runtime/timing.h>

typedef void rt_game_register_cvars_fn(void);
typedef rt_result rt_game_initialize_fn(void);
typedef void rt_game_shutdown_fn(void);
typedef void rt_game_update_fn(rt_time_delta delta);
typedef void rt_game_render_fn(void);

typedef struct {
    rt_game_register_cvars_fn *RegisterCVARs;
    rt_game_initialize_fn *Init;
    rt_game_shutdown_fn *Shutdown;
    rt_game_update_fn *Update;
    rt_game_render_fn *Render;
} rt_game_api;


typedef rt_game_api rt_load_game_api_fn(void);

#ifdef __cplusplus
#define LOAD_GAME_API_FUNC extern "C" RT_DLLEXPORT rt_game_api rtLoadGameAPI()
#else
#define LOAD_GAME_API_FUNC RT_DLLEXPORT rt_game_api rtLoadGameAPI()
#endif

#endif
